/* System manager IRQ routines */

#include "SystemMgr-ck.h" 
#include <SysCore/SC_io.h>


void *SysIRQHandler[16] = {
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0
};

void SysIRQHandlerRegister(unsigned char IntNum, void (*IRQHandler)(struct SSSysRegs_s *regsp)) {
SysIRQHandler[IntNum] = IRQHandler;
}

void SysIRQHandlerUnregister(unsigned char IntNum) {
SysIRQHandler[IntNum] = 0;
}

void SysIRQRemap() {

SC_IOPortWrite(0x20, 0x11);
SC_IOPortWrite(0xA0, 0x11);
SC_IOPortWrite(0x21, 0x20);
SC_IOPortWrite(0xA1, 0x28);
SC_IOPortWrite(0x21, 0x04);
SC_IOPortWrite(0xA1, 0x02);
SC_IOPortWrite(0x21, 0x01);
SC_IOPortWrite(0xA1, 0x01);
SC_IOPortWrite(0x21, 0x0);
SC_IOPortWrite(0xA1, 0x0);
}

void SysIRQInstall() {

SysIRQRemap();
SysIDTEntrySet(32, (unsigned)SysIRQ0, 0x08, 0);
SysIDTEntrySet(33, (unsigned)SysIRQ1, 0x08, 0);
SysIDTEntrySet(34, (unsigned)SysIRQ2, 0x08, 0);
SysIDTEntrySet(35, (unsigned)SysIRQ3, 0x08, 0);
SysIDTEntrySet(36, (unsigned)SysIRQ4, 0x08, 0);
SysIDTEntrySet(37, (unsigned)SysIRQ5, 0x08, 0);
SysIDTEntrySet(38, (unsigned)SysIRQ6, 0x08, 0);
SysIDTEntrySet(39, (unsigned)SysIRQ7, 0x08, 0);
SysIDTEntrySet(40, (unsigned)SysIRQ8, 0x08, 0);
SysIDTEntrySet(41, (unsigned)SysIRQ9, 0x08, 0);
SysIDTEntrySet(42, (unsigned)SysIRQ10, 0x08, 0);
SysIDTEntrySet(43, (unsigned)SysIRQ11, 0x08, 0);
SysIDTEntrySet(44, (unsigned)SysIRQ12, 0x08, 0);
SysIDTEntrySet(45, (unsigned)SysIRQ13, 0x08, 0);
SysIDTEntrySet(46, (unsigned)SysIRQ14, 0x08, 0);
SysIDTEntrySet(47, (unsigned)SysIRQ15, 0x08, 0);
}

void SysIRQDispatcher(struct SSSysRegs_s *regsp) {

void (*CurrentIRQHandler)(struct SSSysRegs_s *regsp);

CurrentIRQHandler = SysIRQHandler[(regsp->int_no - 32)];

if (CurrentIRQHandler) {
	CurrentIRQHandler(regsp);
}

if ((regsp->int_no >= 40) && (regsp->int_no <= 47)) {
	SC_IOPortWrite(0xA0,0x20);
}

SC_IOPortWrite(0x20,0x20);
}

