/* Timer manager CoreKernel part (to manipulate hardware) */

#include <CoreKernel/SystemMgr-ck/SystemMgr-ck.h>
#include "TimeMgr.h"
#include <SysCore/SC_io.h>
#include <libSystem/TermPCCons/TermPCCons.h>

unsigned long SystemTimer = 0;

void TimeTimerSet(unsigned char ClockFreq) {
unsigned int TimerClockDivisor;

TimerClockDivisor = 1193180 / ClockFreq;
SC_IOPortWrite(0x43,0x36);
SC_IOPortWrite(0x40, TimerClockDivisor & 0xFF);
SC_IOPortWrite(0x40, TimerClockDivisor >> 8);
}

void TimerIRQInstall() {
TimeTimerSet(100);
TermTextPrint("\t* Time manager: Installing system clock IRQ handler\n",WHITE,BLACK);
SysIRQHandlerRegister(0,Timer8254Handler);
TermTextPrint("\t* Time manager: Shutdowning system in 30 seconds\n",WHITE,BLACK);
}

void Timer8254Handler(struct SSSysRegs_s *dummyp) {
SystemTimer++;

if ((SystemTimer % 1000) == 0) {
	TermTextPrint("System uptime: +10 second\n",WHITE,BLACK);
}
if (SystemTimer == 3000) { SysHalt(); }
}

