/* SC_cpu.c

This file defines routines to set registers, read them and pass to multiples modes of the cpu.

*/

typedef struct {
unsigned int r[31] 
unsigned int cflags
} s_CPURegs;

unsigned int SC_CPURegsSet(s_CPURegs *cregs) {
asm("
	mov %[r1], %eax;
	mov %[r2], %ax;
	mov %[r3], %ah;
	mov %[r4], %al" : : [r1] "m" (cregs->r[0]), [r2] "m" (cregs->r[1]), [r3] "m" (cregs->r[2]), [r4] "m" (cregs->r[3]) : "eax", "ax", "ah", "al" );

asm("
	mov %[r1], %ebx;
	mov %[r2], %bx;
	mov %[r3], %bh;
	mov %[r4], %bl" : : [r1] "m" (cregs->r[4]), [r2] "m" (cregs->r[5], [r3] "m" (cregs->r[6]), [r4] "m" (cregs->r[7]) : "ebx", "bx", "bh", "bl" );

asm("
	mov %[r1], %ecx;
	mov %[r2], %cx;
	mov %[r3], %ch;
	mov %[r4], %cl" : : [r1] "m" (cregs->r[8]), [r2] "m" (cregs->r[9]), [r3] "m" (cregs->r[10]), [r4] "m" (cregs->r[11]) : "ecx", "cx", "ch", "cl" );

asm("
	mov %[r1], %edx;
	mov %[r2], %dx;
	mov %[r3], %dh;
	mov %[r4], %dl" : : [r1] "m" (cregs->r[12]), [r2] "m" (cregs->r[13]), [r3] "m" (cregs->r[14]), [r4] "m" (cregs->r[15]) : "edx", "dx", "dh", "dl" );

asm("
	mov %[r1], %edi;
	mov %[r2], %esi;
	mov %[r3], %esp;
	mov %[r4], %ebp" : : [r1] "m" (cregs->r[16]), [r2] "m" (cregs->r[17]), [r3] "m" (cregs->r[18]), [r4] "m" (cregs->r[19]) : "edi", "esp", "esi","ebp" );

asm("
	mov %[r1], %eds;
	mov %[r2], %ees;
	mov %[r3], %ess;
	mov %[r4], %ecs" : : [r1] "m" (cregs->r[0]), [r2] "m" (cregs->r[1]), [r3] "m" (cregs->r[2]), [r4] "m" (cregs->r[3]) : "eds", "ees", "ess", "ecs" );
}

unsigned int SC_CPURegsGet(s_CPURegs *cregs) {
asm("
	mov %[r1], %eax;
	mov %[r2], %ax;
	mov %[r3], %ah;
	mov %[r4], %al" : [r1] "m" (cregs->r[0]), [r2] "m" (cregs->r[1]), [r3] "m" (cregs->r[2]), [r4] "m" (cregs->r[3]) : :);

asm("
	mov %[r1], %ebx;
	mov %[r2], %bx;
	mov %[r3], %bh;
	mov %[r4], %bl" : [r1] "m" (cregs->r[4]), [r2] "m" (cregs->r[5], [r3] "m" (cregs->r[6]), [r4] "m" (cregs->r[7]) : :);

asm("
	mov %[r1], %ecx;
	mov %[r2], %cx;
	mov %[r3], %ch;
	mov %[r4], %cl" : [r1] "m" (cregs->r[8]), [r2] "m" (cregs->r[9]), [r3] "m" (cregs->r[10]), [r4] "m" (cregs->r[11]) : :);

asm("
	mov %[r1], %edx;
	mov %[r2], %dx;
	mov %[r3], %dh;
	mov %[r4], %dl" : [r1] "m" (cregs->r[12]), [r2] "m" (cregs->r[13]), [r3] "m" (cregs->r[14]), [r4] "m" (cregs->r[15]) : : "edx", "dx", "dh", "dl" );

asm("
	mov %[r1], %edi;
	mov %[r2], %esi;
	mov %[r3], %esp;
	mov %[r4], %ebp" : [r1] "m" (cregs->r[16]), [r2] "m" (cregs->r[17]), [r3] "m" (cregs->r[18]), [r4] "m" (cregs->r[19]) : : "edi", "esp", "esi", "ebp" );

asm("
	mov %[r1], %eds;
	mov %[r2], %ees;
	mov %[r3], %ess;
	mov %[r4], %ecs; " : : [r1] "m" (cregs->r[0]), [r2] "m" (cregs->r[1]), [r3] "m" (cregs->r[2]), [r4] "m" (cregs->r[3]) : "eds","ees","ess","ecs" );
