/* Keyboard base driver */

#include <CoreKernel/SystemMgr-ck/SystemMgr-ck.h>
#include <SysCore/SC_io.h>
#include "KeyboardBase.h"
#include "KeyboardUSMap.h"
#include <libSystem/TermPCCons/TermPCCons.h>


unsigned char KbdStatus = 0;

void InputKbdIRQInstall() {
	TermTextPrint("\t* Input manager: Installing keyboard handler\n",WHITE,BLACK);
	SysIRQHandlerRegister(1,InputKbdIRQHandler);
	SC_IOPortWrite(0x21, 0xFD); // Does not work
} 

void InputKbdIRQHandler(struct SSSysRegs_s *dummyp) {
	unsigned char KbdScancode = 0;
	TermTextPrint("* Input manager/Keyboard: Acquiring scancode\n", WHITE,BLACK);
	KbdScancode = SC_IOPortRead(0x60);
	if (KbdScancode & 0x80) {
		switch (BaseKbdMap[KbdScancode]) {
				case 160:
					KbdStatus - 128;
					break;
				case 161:
					KbdStatus - 64;
					break;
			}
	}
	else {
		TermTextPrint("* Input manager/Keyboard: Checking for special scancodes\n",WHITE,BLACK);
		if ((BaseKbdMap[KbdScancode] >= 160) && (BaseKbdMap[KbdScancode] <= 168)) {
			switch (BaseKbdMap[KbdScancode]) {
				case 160: // Shift
					KbdStatus | 128;
					break;
				case 161: // Alt
					KbdStatus | 64;
					break;
			}
		}
		else {
			TermTextPrint("Printing key on terminal\n",WHITE,BLACK);
			if (KbdStatus & 0x80) {
				TermCharPut(BaseKbdShiftMap[KbdScancode],WHITE,BLACK);
			}
			else {
				TermCharPut(BaseKbdMap[KbdScancode],WHITE,BLACK);
			}
		}
	}
}
