/* TermPCCons.h

This is the header file of the console manager of SyntheSys.
It allows you to call it's routines from external applications and other parts of
the kernel.

*/

typedef struct {
unsigned char x;
unsigned char y;
unsigned char width;
unsigned char height;
} ConsCursorPos_s; // Structure that contains a console status

#define BLACK 0
#define BLUE 1
#define GREEN 2
#define CYAN 3
#define RED 4
#define WHITE 15

extern int TermConsInit(void);
extern int TermTextPrint(char *text, unsigned char fgcolor, unsigned char bgcolor);
extern unsigned long TermCellGetAddress(unsigned char row, unsigned char column);
extern unsigned long TermCellGetAttrAddress(unsigned char row, unsigned char column);
extern int TermScroll(unsigned int lines);
extern int TermCellGetPosByAddr(unsigned long addr, ConsCursorPos_s *addrcurs);
extern void TermScreenClear(void);
extern void TermCursorSetAtXY(unsigned char x, unsigned char y);
extern void TermCharPut(unsigned char CharToPut, unsigned char fgcolor, unsigned char bgcolor);
